#define DEBUG 1
//#define SIMULATION 1

#define BUILD_NO      0
#define VERSION_MAJOR 0
#define VERSION_MINOR 3

#define BAUD 115200L

#define F_CPU         16384000          // system clock in Hz

// IO macros

#define FLASH_CS_LOW    PORTD &= ~(1<<PD2);
#define FLASH_CS_HIGH   PORTD |=  (1<<PD2);

#define TLC5940_CS_LOW  PORTD &= ~(1<<PD6);
#define TLC5940_CS_HIGH PORTD |=  (1<<PD6);

#define XLAT_LOW        PORTB &= ~(1<<PB0);
#define XLAT_HIGH       PORTB |=  (1<<PB0);

#define VPRG_LOW        PORTD &= ~(1<<PD7);
#define VPRG_HIGH       PORTD |=  (1<<PD7);

#define BLANK_LOW       PORTB &= ~(1<<PB1);
#define BLANK_HIGH      PORTB |=  (1<<PB1);

#define MUX_BUS         PORTD &= ~(1<<PD5);
#define MUX_STANDALONE  PORTD |=  (1<<PD5);

#define TRIGGER_IN      ((PINC & 0x3F) | ((PIND<<3) & 0xC0))

#define MODE_CONFIG     1
#define MODE_EVENT      2
#define MODE_BUS        3

#define NOP_LED 0x8000  

#define nop() asm volatile("nop")                    

// don't change below, will be calculated

#define UBRR_VAL  ((F_CPU+BAUD*8)/(BAUD*16)-1)  
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD-1000) 
 
#if ((BAUD_ERROR>15) || (BAUD_ERROR<-15))
  #error Systematic baud error above 1.5% which is too high! 
#endif

